/* Zeo - Z/Geometry and optics computation library.
 * Copyright (C) 2005 Tomomichi Sugihara (Zhidao)

 Zeo is a handy library for computational geometry and optics
 including:
 - color and optics computations
 - 2D/3D vectors and matrices
 - 6D spatial vectors and matrices
 - 3D frame and coordinate transportation
 - Euler parameter (unit quaternion)
 - 3D shape elements (plane, edge and triangle)
 - 3D shape primitives (box, sphere, cylinder, cone, ellipsoid,
   elliptic cylinder, polyhedron)
 - multiple 3D shapes
 - trianglation of non-convex
 - bounding volume (AABB, OBB, boundin ball, convex-hull)
 - collision checking (AABB tree, GJK, Muller-Preparata)
 - principal component analysis of point cloud
 - B-Rep (boundary representation) and boolean operations
 */

#ifndef __ZEO_H__
#define __ZEO_H__

#include <zeo/zeo_mat6d.h>
#include <zeo/zeo_ep.h>
#include <zeo/zeo_col.h>
#include <zeo/zeo_mshape.h>

#endif /* __ZEO_H__ */
